﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace XNA4KinectHandler
{
    public class SkeletonTracking
    {
        SkeletonTrackingBuffer[] tb = null;

        public SkeletonTracking()
        {
            tb = new SkeletonTrackingBuffer[14];
            for (int i = 0; i < 14; i++)
            {
                tb[i] = new SkeletonTrackingBuffer();
            }
        }

        public Vector3 setTrackingBuffer(Vector3 value, int i)
        {
            return tb[i].getAveg(value);
        }
    }

    class SkeletonTrackingBuffer
    {
        int TrackingNum_Buffer = 0;

        Vector3[] avg = new Vector3[2];
        Vector3 avg_sum = Vector3.Zero;
        Vector3 temp = Vector3.Zero;

        public SkeletonTrackingBuffer()
        {
            for(int i = 0; i<2; i++)
                avg[i] = Vector3.Zero;
        }

        public Vector3 getAveg(Vector3 value)
        {
            TrackingNum_Buffer += 1;
            temp += value;

            if (TrackingNum_Buffer >= 2 && TrackingNum_Buffer < 3)
            {
                avg[0] = temp / TrackingNum_Buffer;
            }
            if (TrackingNum_Buffer >= 3 && TrackingNum_Buffer < 4)
            {
                avg[1] = temp / TrackingNum_Buffer;
                TrackingNum_Buffer = 0;
                temp = Vector3.Zero;
            }

            avg_sum = avg[0] + avg[1] + value;
            avg_sum /= 3;

            avg_sum.X = (int)(avg_sum.X * 1000) * 0.001f;
            avg_sum.Y = (int)(avg_sum.Y * 1000) * 0.001f;
            avg_sum.Z = (int)(avg_sum.Z * 1000) * 0.001f;

            return avg_sum;
        }
    }
}
